Subject: bug#21376: 25.0.50; Python tests fail on MS-Windows -- issues with the prompt

From: Eli Zaretskii <[email-masked]>
Date: Wed, 16 Aug 2017 17:26:28 +0300

> From: [email-masked]
> Cc: [email-masked],  [email-masked]
> Date: Tue, 15 Aug 2017 21:41:18 -0400
> 
> >    FAILED  python-shell-make-comint-4
> >    FAILED  python-shell-prompt-detect-1
> >    FAILED  python-shell-prompt-detect-2
> >    FAILED  python-shell-prompt-set-calculated-regexps-6
> >
> > I show below the relevant portions of python-tests.log.
> >
> > I need help in figuring out what causes these.  One possible suspect
> > is some buffering issue, due to which Emacs does not receive the
> > prompt that Python prints.  Another possibility might be the version
> > of the Python (I have 2.6.6 installed).  Or maybe something else.
> 
> It seems to be a bug in Python 2.x on Windows (Python 3.6.x doesn't show
> the problem).  In unbuffered mode it rejects carriage returns.  Compare
> results of
> 
>     printf 'print("hello world")\r\n' > hello-world-with-crnl.py
>     python -i    < hello-world-with-crnl.py
>     python -i -u < hello-world-with-crnl.py
> 
>     printf 'print("hello world")\n' > hello-world-with-nl.py
>     python -i    < hello-world-with-nl.py
>     python -i -u < hello-world-with-nl.py
> 
> (Setting the PYTHONUNBUFFERED environment variable, as python.el does,
> is equivalent to passing '-u'.)
> 
> The bug can be worked around with the following patch:

Thanks, but after applying the patch I still see the same 4 tests
mentioned above failing.  Do I need to do something in addition to
just running the test, as in

  cd test && make lisp/progmodes/python-tests.log

?